



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++实现程序单实例运行的两种方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++实现程序单实例运行的两种方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 13:14:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>简介</h2>
<blockquote><p>在我们编写程序的时候，经常会注意到的一个问题就是如何能够让程序只运行一个实例，确保不会让同一个程序多次运行，从而产生诸多相同进程，给我们的带来不便呢？那么常用的有以下四种方法，第一种方法是通过<strong>扫描进程列表比对进程名</strong>来检测，第二种方法是通过<strong>枚举程序窗口</strong>的方式，第三种方法是采用<strong>共享全局变量</strong>来实现，第四种方法是通过<strong>创建互斥体</strong>来实现。<br /><br />
那么在这些方法中，第一种和第二种方法是有缺陷的，扫描进程列表比对进程名容易对相同进程名字的不同程序产生误报，枚举窗口不适用于无窗口程序且与扫描进程列表的方法也有相同的缺陷。所以本文笔者为大家介绍第三种方法与第四种方法的具体实现。</p></blockquote>
<h2>代码实现</h2>
<p><strong>1. 互斥体实现方式</strong></p>
<pre class="prettyprint linenums"><code>//////////////////////////////////////////////////////////////////<br />
//<br />
// FileName : SingleRunByMutex.cpp<br />
// Creator : PeterZheng<br />
// Date : 2019/2/16 11:21<br />
// Comment : 互斥体实现进程单实例运行<br />
//<br />
//////////////////////////////////////////////////////////////////

#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;Windows.h&gt;

using namespace std;

// 使用互斥体保证单体运行<br />
BOOL IsAlreadyRun()<br />
{<br />
	HANDLE hMutex = NULL;<br />
	hMutex = CreateMutex(NULL, FALSE, &quot;MYFLAG&quot;);<br />
	if (hMutex != NULL)<br />
	{<br />
		if (ERROR_ALREADY_EXISTS == GetLastError())<br />
		{<br />
			ReleaseMutex(hMutex);<br />
			return TRUE;<br />
		}<br />
	}<br />
	return FALSE;<br />
}

// 主函数<br />
int APIENTRY WinMain(_In_ HINSTANCE hInstance, _In_opt_ HINSTANCE hPrevInstance, _In_ LPSTR lpCmdLine, _In_ int nShowCmd)<br />
{<br />
	if (IsAlreadyRun())<br />
	{<br />
		MessageBox(NULL, &quot;This Program is already RUN !&quot;, &quot;Tips&quot;, MB_OK);<br />
	}<br />
	else<br />
	{<br />
		MessageBox(NULL, &quot;I am RUN !&quot;, &quot;Tips&quot;, MB_OK);<br />
		Sleep(30000);<br />
	}<br />
	ExitProcess(0);<br />
	return 0;<br />
}<br />
</code></pre>
<p><strong>2. 共享全局变量实现方式</strong></p>
<pre class="prettyprint linenums"><code>//////////////////////////////////////////////////////////////////<br />
//<br />
// FileName : SingleRunByShareSeg.cpp<br />
// Creator : PeterZheng<br />
// Date : 2019/2/16 11:40<br />
// Comment : 通过共享全局变量的方式实现进程单实例运行<br />
//<br />
//////////////////////////////////////////////////////////////////

#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;Windows.h&gt;

using namespace std;

// 创建共享内存段<br />
#pragma data_seg(&quot;sharedata&quot;)<br />
DWORD dwFlagId = 0xEE;<br />
#pragma data_seg()<br />
#pragma comment(linker, &quot;/SECTION:sharedata,RWS&quot;)

// 使用共享内存段保证单体运行<br />
BOOL IsAlreadyRun()<br />
{<br />
	if (dwFlagId == 0xEF)<br />
	{<br />
		return TRUE;<br />
	}<br />
	return FALSE;<br />
}

// 主函数<br />
int APIENTRY WinMain(_In_ HINSTANCE hInstance, _In_opt_ HINSTANCE hPrevInstance, _In_ LPSTR lpCmdLine, _In_ int nShowCmd)<br />
{<br />
	if (IsAlreadyRun())<br />
	{<br />
		MessageBox(NULL, &quot;This Program is already RUN !&quot;, &quot;Tips&quot;, MB_OK);<br />
	}<br />
	else<br />
	{<br />
		MessageBox(NULL, &quot;I am RUN !&quot;, &quot;Tips&quot;, MB_OK);<br />
		dwFlagId = 0xEF;<br />
		Sleep(30000);<br />
	}<br />
	ExitProcess(0);<br />
	return 0;<br />
}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1kym49.html">51node1264&lpar;判断线段相交）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jk5z8.html">python初学杂记</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r1p0m8.html">C&num;防止反编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw5me8.html">&OpenCurlyDoubleQuote;ORA-01033&colon;ORACLE initialization or shutdown in progress&rdquo;错误的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96w76jq.html">BZOJ2733 &lbrack;HNOI2012&rsqb;永无乡</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952xjv9.html">SQL Server技术问题之自定义函数优缺点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w55mxq.html">eclipse中web工程新建jsp文件报错&colon;The superclass &amp;quot&semi;javax&period;servlet&period;http&period;HttpServlet&amp;quot&semi; was not found on the Java Build Path</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1o1we9.html">开机就提示&OpenCurlyDoubleQuote;请安装TCP&sol;IP协议，error&equals;10106&rdquo;的解决的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6ovr8.html">&lbrack;Windows Azure&rsqb; Querying Tables and Entities</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okyy39.html">iframe 的基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0mg48.html">基于ELK的数据分析实践&mdash;&mdash;满满的干货送给你</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0mze8.html">2n皇后问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0mmx9.html">洛谷P2388 阶乘之乘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0men9.html">CSS动画总结与呼吸灯效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdlj249.html">从输入URL到浏览器显示页面发生了什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvyz48.html">NSMutableArray 增删操作测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogvk18.html">Android报&OpenCurlyDoubleQuote;android&period;content&period;res&period;Resources&dollar;NotFoundException&colon; String resource ID &num;0x2&rdquo;错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4jgpz9.html">SSL SSH</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw72x48.html">ARP【地址解析协议】理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j64d3q.html">SpringBoot入门之基于Druid配置Mybatis多数据源</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90rr30j9.html">PXC快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwzprq.html">移植 Qt 至 tiny210 详细过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oorjx8.html">SpringBoot系列&mdash;&mdash;mail</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlll4d6q.html">hadoop小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwwldz8.html">Sklearn中二分类问题的交叉熵计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ww5ygq.html">webpack-dev-server不是内部或外部命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlllzg6q.html">Stackoverflow每日问题  系列前言</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rvz508.html">laravel前后台路由分离</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1mzwg9.html">洛谷P4103 &lbrack;HEOI2014&rsqb;大工程&lpar;虚树 树形dp&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jpzr5q.html">loj&num;6030&period; 「雅礼集训 2017 Day1」矩阵&lpar;贪心 构造&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
